View Issue Details

IDProjectCategoryView StatusLast Update
0025005LazarusLCLpublic2014-10-16 03:59
Reporteryang jixianAssigned Toyang jixian 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
PlatformwindowsOSwindowsOS Version
Product Version1.0.12Product Build 
Target Version1.4Fixed in Version1.3 (SVN) 
Summary0025005: Black area at the right side of visible component on resize
DescriptionSet the visible components align in [alTop, alBottom, alClient] or Anchors = [akTop,akLeft,akRight,akBottom], resize the form, the black area appear.

Seems this bug exists in every version of Lazarus.
TagsNo tags attached.
Fixed in Revision
LazTarget-
WidgetsetWin32/Win64
Attached Files

Activities

yang jixian

2013-09-12 03:59

developer  

project1.zip (128,513 bytes)

Martin Friebe

2013-09-14 01:25

manager   ~0070043

I was not able to reproduce.
Can you provide screenshot?

Is it during design?
Or is it at runtime (F9)?

In your app the panel was already anchored, so I did not make changes, correct? I just resized the form.

Which Windows? XP, Vista, 7, 8?

yang jixian

2013-09-14 06:14

developer  

resizewidth.png (18,819 bytes)
resizewidth.png (18,819 bytes)

yang jixian

2013-09-14 06:25

developer   ~0070044

It it produced by resizing the width of the form with mouse, not only runtime but also designtime.

There is no need to change the demo, just run it to resize, or resize the designtime form.

Seems there is no such bug on XP.

But on Windows 7, 32 bit or 64 bit, the bug does always exists, Lazarus 32 bit or 64 bit makes no change.

When I write a visual component inherited from TCustomControl, and rewrite the Paint procedure with a bitmap copied, the bug is very very clear on align=alClient.

Martin Friebe

2013-09-14 19:46

manager   ~0070061

Sorry, can't reproduce it here (vista 32 bit, tried different themes). Maybe one of my colleagues.

yang jixian

2013-09-15 04:18

developer   ~0070067

On Vista32, it is not clear. Win7 is needed to test.

And we must set operator system performance options to "Adjust for best appearance". Therefore the window width is changing at the time of resizing, not "Adjust for best performance", a rectangular area instead of the real window.

yang jixian

2013-09-15 04:26

developer   ~0070068

It is the bug of windows widgets. And there are some diffrent from Delphi, for example, WM_EXITSIZEMOVE, WM_ENTERSIZEMOVE, no effect with Lazarus, but with Delphi it works.
And another bug on the resize action is that there is not any message triggered while the mouse is up.

yang jixian

2013-09-15 04:29

developer   ~0070069

In some condition, we just want redraw or do something else after resize. If there is no such message, it is difficult.

Bart Broersma

2013-11-01 19:34

developer   ~0071079

Last edited: 2013-11-01 19:35

View 2 revisions

I cannot see it on Win7-64 (32-bit Lazarus).
At designtime, when I very quickly resize the form (drag the border with mouse), it seems that the drawing of the panel lacks just a few milliseconds, and for that time you I can see a (very small) black area (just a very few pixels).
No such black area remains once the resize is done.

Martin Friebe

2014-01-20 13:39

manager   ~0072560

Not a regression, moved target

Juha Manninen

2014-09-10 00:06

developer   ~0077018

I can see the same effect as Bart.
yang jixian, please test with the latest trunk. You tested with an old 1.0.x version.

yang jixian

2014-09-20 07:18

developer   ~0077447

I updated lazarus to today svn, but the problem still exists.

Mike Thompson

2014-09-23 14:16

developer   ~0077561

Last edited: 2014-09-23 17:56

View 3 revisions

Tested with 1.3/win32/Win 7. I'm not seeing this issue either (design time and run time both behave properly). I ensured my system was set to "Adjust for best performance". Trying to think what could cause this I tried changing Windows Themes (Classic, Basic, Aero) and tried disabling Manifest at Project level. No change in behaviour each time.

@yang: Do you have access to multiple PC's? Does this reproduce on all of them? I'm wondering if it's not a video card/driver issue - or something related to a specific PC? If it's not that, when you run Lazarus, have you changed any of the Compatibility settings (I've just tried a few with no change - but maybe a certain combination...)?

> When I write a visual component inherited from TCustomControl,
> and rewrite the Paint procedure with a bitmap copied, the bug
> is very very clear on align=alClient.

To be clear, when you say the bug is still present, did you test using the uploaded test project, or another project - this TCustomControl descendant? If it's in the TCusomControl descendant, can you create & upload a new test project?

yang jixian

2014-10-16 03:56

developer   ~0078265

The test returns the same result on my different PCs.

It is tested with newest svn just now, it still appeared, but seems not obviously.
When the panel's BevelOuter is not bvRaised, there is not such bug.

Then the form is maximized, no bug appeared.

I found the bug when I test SpkToolBar component, resize or maximize the form with the component on it, there is black area, it it not acceptable for gui on windows.
But now there is not such problem, so I think it is solved.

Issue History

Date Modified Username Field Change
2013-09-12 03:59 yang jixian New Issue
2013-09-12 03:59 yang jixian File Added: project1.zip
2013-09-14 00:43 Martin Friebe LazTarget - => 1.2
2013-09-14 01:25 Martin Friebe Note Added: 0070043
2013-09-14 06:14 yang jixian File Added: resizewidth.png
2013-09-14 06:25 yang jixian Note Added: 0070044
2013-09-14 19:46 Martin Friebe Note Added: 0070061
2013-09-15 04:18 yang jixian Note Added: 0070067
2013-09-15 04:26 yang jixian Note Added: 0070068
2013-09-15 04:29 yang jixian Note Added: 0070069
2013-11-01 19:34 Bart Broersma Note Added: 0071079
2013-11-01 19:35 Bart Broersma Note Edited: 0071079 View Revisions
2014-01-14 15:43 Martin Friebe Target Version 1.0.14 => 1.2.0
2014-01-20 13:39 Martin Friebe LazTarget 1.2 => 1.4
2014-01-20 13:39 Martin Friebe Note Added: 0072560
2014-01-20 13:39 Martin Friebe Target Version 1.2.0 => 1.4
2014-09-10 00:03 Juha Manninen LazTarget 1.4 => -
2014-09-10 00:03 Juha Manninen Target Version 1.4 =>
2014-09-10 00:06 Juha Manninen Note Added: 0077018
2014-09-20 07:18 yang jixian Note Added: 0077447
2014-09-23 14:16 Mike Thompson Note Added: 0077561
2014-09-23 14:23 Mike Thompson Note Edited: 0077561 View Revisions
2014-09-23 17:56 Mike Thompson Note Edited: 0077561 View Revisions
2014-10-16 03:56 yang jixian Note Added: 0078265
2014-10-16 03:59 yang jixian Status new => closed
2014-10-16 03:59 yang jixian Assigned To => yang jixian
2014-10-16 03:59 yang jixian Resolution open => fixed
2014-10-16 03:59 yang jixian Fixed in Version => 1.3 (SVN)
2014-10-16 03:59 yang jixian Target Version => 1.4